import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogHubAndSpoke'] = []
    nbr = 0
    for obj in get_prgm_classes():
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogHubAndSpoke, [], {})
        obj_coll_names = ['r2']
        r2__just = [c.range for c in obj.out_edges if c.action == "activate"]
        if empty(r2__just):
            continue
        r2__items = next_classes_with_justifications(nodes_in,r2__just)
        for r2 in r2__items.keys():
            r2__evidence = r2__items[r2]
            r2Player = Player(r2, 'r2', -1,RecogHubAndSpoke,r2__evidence, {})
            r2_coll_names = ['colleague']
            colleague__just = [c.range.executing[0] for c in r2.out_edges if len(c.range.executing) > 0]
            if empty(colleague__just):
                continue
            colleague__items = next_classes_with_justifications(nodes_in,colleague__just)
            for colleague in colleague__items.keys():
                colleague__evidence = colleague__items[colleague]
                colleaguePlayer = Player(colleague, 'colleague', -1,RecogHubAndSpoke,colleague__evidence, {})
                colleague_coll_names = ['r3']
                r3__just = [c.range for c in obj.out_edges if c.action == "activate" and c.range != r2]
                if empty(r3__just):
                    continue
                r3__items = next_classes_with_justifications(nodes_in,r3__just)
                for r3 in r3__items.keys():
                    r3__evidence = r3__items[r3]
                    r3Player = Player(r3, 'r3', -1,RecogHubAndSpoke,r3__evidence, {})
                    r3_coll_names = ['center']
                    center__just = [c.range.executing[0] for c in r3.out_edges if len(c.range.executing) > 0 and len(c.range.executing[0].with_accepts) > 0 and len(how_related(colleague, c.range.executing[0])) == 1]
                    if empty(center__just):
                        continue
                    center__items = next_classes_with_justifications(nodes_in,center__just)
                    for center in center__items.keys():
                        center__evidence = center__items[center]
                        centerPlayer = Player(center, 'center', -1,RecogHubAndSpoke,center__evidence, {})
                        center_coll_names = []
                        if empty(setdiff(center_coll_names,centerPlayer.with.keys())):
                            dict_put(r3Player.with,'center',centerPlayer)
                    if empty(setdiff(r3_coll_names,r3Player.with.keys())):
                        dict_put(colleaguePlayer.with,'r3',r3Player)
                if empty(setdiff(colleague_coll_names,colleaguePlayer.with.keys())):
                    dict_put(r2Player.with,'colleague',colleaguePlayer)
            if empty(setdiff(r2_coll_names,r2Player.with.keys())):
                dict_put(objPlayer.with,'r2',r2Player)
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogHubAndSpoke'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogHubAndSpoke']
